## mingw-w64-precice-2.5.0-6.src.tar.zst

=== thirdparty/fmt/CMakeLists.txt ===
add_library(fmt-header-only INTERFACE IMPORTED GLOBAL)
set_target_properties(fmt-header-only
  PROPERTIES
  INTERFACE_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_LIST_DIR}/include"
  INTERFACE_COMPILE_DEFINITIONS FMT_HEADER_ONLY=1)

=== thirdparty/json/CMakeLists.txt ===
add_library(JSON INTERFACE IMPORTED GLOBAL)
set_property(TARGET JSON PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_LIST_DIR}/include")

=== tools/releasing/packaging/debian/changelog ===
libprecice1 (1.6.1) experimental; urgency=low

  * New upstream release 1.6.1

 -- the preCICE developers <precice@mailman.informatik.uni-stuttgart.de>  Fri, 13 Sep 2019 11:07:42 +0200

libprecice1 (1.6.0) experimental; urgency=low

  * New upstream release 1.6.0

 -- the preCICE developers <precice@mailman.informatik.uni-stuttgart.de>  Wed, 11 Sep 2019 19:58:06 +0200

libprecice1 (1.1.1) experimental; urgency=low

  * Fix SConstruct symlink build target failing when using lowercase build (debug, release) names.

 -- the preCICE developers <precice@mailman.informatik.uni-stuttgart.de>  Thu, 19 Apr 2018 16:37:34 +0200

libprecice2 (2.0.0) experimental; urgency=low

  * New upstream release 2.0.0

 -- the preCICE developers <info@precice.org>  Mon, 03 Feb 2020 13:14:16 +0100

libprecice2 (2.0.1) experimental; urgency=low

  * New upstream release 2.0.1

 -- the preCICE developers <info@precice.org>  Tue, 25 Feb 2020 11:53:39 +0100

libprecice2 (2.0.2) experimental; urgency=low

  * New upstream release 2.0.2

 -- the preCICE developers <info@precice.org>  Wed, 01 Apr 2020 11:47:04 +0200

libprecice2 (2.1.0) experimental; urgency=low

  * New upstream release 2.1.0

 -- the preCICE developers <info@precice.org>  Tue, 21 Jul 2020 09:12:08 +0200

libprecice2 (2.1.1) experimental; urgency=low

  * New upstream release 2.1.1

 -- the preCICE developers <info@precice.org>  Tue, 06 Oct 2020 11:43:48 +0200

libprecice2 (2.2.0) experimental; urgency=low

  * New upstream release 2.2.0

 -- the preCICE developers <info@precice.org>  Mon, 18 Jan 2021 21:44:05 +0100

libprecice2 (2.2.1) experimental; urgency=low

  * New upstream release 2.2.1

 -- the preCICE developers <info@precice.org>  Tue, 18 May 2021 09:37:04 +0200

libprecice2 (2.3.0) experimental; urgency=low

  * New upstream release 2.3.0

 -- the preCICE developers <info@precice.org>  Wed, 15 Sep 2021 16:37:46 +0200

libprecice2 (2.4.0) experimental; urgency=low

  * New upstream release 2.4.0

 -- the preCICE developers <info@precice.org>  Mon, 09 May 2022 13:20:21 +0200

libprecice2 (2.5.0) experimental; urgency=low

  * New upstream release 2.5.0

 -- the preCICE developers <info@precice.org>  Thu, 04 Aug 2022 08:57:12 +0200

=== PKGBUILD ===
# Maintainer: Rafal Brzegowy <rafal.brzegowy@yahoo.com>
# Contributor: Raed Rizqie <raed.rizqie@gmail.com>

_realname=precice
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2.5.0
pkgrel=6
pkgdesc='A Coupling Library for Partitioned Multi-Physics Simulations on Massively Parallel Systems (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
url='https://www.precice.org'
msys2_repository_url='https://github.com/precice/precice'
license=('spdx:LGPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-boost"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         #"${MINGW_PACKAGE_PREFIX}-petsc"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-python-numpy")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-msmpi"
             #"${MINGW_PACKAGE_PREFIX}-ninja"
             #"${MINGW_PACKAGE_PREFIX}-petsc-build"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "git")
source=(https://github.com/precice/precice/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz
        001-fix-libprecice-dll-installation.patch
        002-fix-build-with-libxml2-2.12.patch)
sha256sums=('76ec6ee0d1a66f6f3d3d2d11f03cfc5aa7ef4d9e5deb9b7a4b4455ec7f796c00'
            '49fe04f9e72d1034b8909a7b593ccf42eeaf5203d9188f71706260948a0fb566'
            '9704b031c26f5be50a2ba08b3757f26d5c661e707145c1a5b170704002019480')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Np1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd ${_realname}-${pkgver}
  apply_patch_with_msg \
    001-fix-libprecice-dll-installation.patch \
    002-fix-build-with-libxml2-2.12.patch
}

build() {
  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  # . ${MINGW_PREFIX}/src/petsc/petsc
  # for build in ${petsc_builds}; do
  #   #export PETSC_ARCH=${build}
  #   export PETSC_ARCH=dmo
  #   export PETSC_DIR=${MINGW_PREFIX}/src/petsc
  # done

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    CXXFLAGS+=" -Wno-c++11-narrowing"
  else
    CXXFLAGS+=" -Wno-narrowing"
  fi

  #Static Build
  mkdir -p "${srcdir}/build-${MSYSTEM}-static" && cd "${srcdir}/build-${MSYSTEM}-static"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake \
      -G"MSYS Makefiles" \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DCMAKE_CXX_STANDARD_LIBRARIES=-lws2_32 \
      -DBUILD_SHARED_LIBS=OFF \
      -DBoost_USE_STATIC_LIBS=ON \
      -DBUILD_TESTING=OFF \
      "${extra_config[@]}" \
      -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
      -DPRECICE_MPICommunication=ON \
      -DPRECICE_PETScMapping=OFF \
      -DPRECICE_PythonActions=ON \
      -DPRECICE_BUILD_TOOLS=OFF \
      -DPC_PETSc_INCLUDE_DIRS="$PREFIX_WIN/src/petsc/include;$PREFIX_WIN/src/petsc/$PETSC_ARCH/include" \
      -Wno-dev \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .

  #Shared Build
  mkdir -p "${srcdir}/build-${MSYSTEM}-shared" && cd "${srcdir}/build-${MSYSTEM}-shared"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake \
      -G"MSYS Makefiles" \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DCMAKE_CXX_STANDARD_LIBRARIES=-lws2_32 \
      -DBUILD_SHARED_LIBS=ON \
      -DBUILD_TESTING=OFF \
      ${extra_config[@]} \
      -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
      -DPRECICE_MPICommunication=ON \
      -DPRECICE_PETScMapping=OFF \
      -DPRECICE_PythonActions=ON \
      -DPC_PETSc_INCLUDE_DIRS="$PREFIX_WIN/src/petsc/include;$PREFIX_WIN/src/petsc/$PETSC_ARCH/include" \
      -Wno-dev \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  #Static Install
  cd "${srcdir}/build-${MSYSTEM}-static"
  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install .

  #Shared Install
  cd "${srcdir}/build-${MSYSTEM}-shared"
  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install .

  # add ".exe" extension to binprecice
  mv "${pkgdir}"${MINGW_PREFIX}/bin/binprecice{,.exe}

  install -Dm644 ${srcdir}/${_realname}-${pkgver}/LICENSE ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}

=== tools/releasing/packaging/Arch_User_Repository/PKGBUILD ===
# Maintainer:  Florian Lindner <florian.lindner@xgm.de>

pkgname=precice
pkgver=2.1.1
pkgrel=1
pkgdesc="A Coupling Library for Partitioned Multi-Physics Simulations on Massively Parallel Systems"
arch=('x86_64')
url="https://www.precice.org"
license=('LGPL3')
depends=('boost' 'libxml2' 'openmpi' 'petsc' 'python-numpy')
makedepends=('cmake' 'eigen')
optdepends=()
provides=('precice')
source=("$pkgname-$pkgver.tar.gz::https://github.com/precice/precice/archive/v${pkgver}.tar.gz")
sha256sums=()

build() {
    cd "${pkgname}-${pkgver}"
    cmake . \
          -DCMAKE_BUILD_TYPE=None \
          -DCMAKE_INSTALL_PREFIX=/usr \
          -DBUILD_SHARED_LIBS=ON \
          -DPRECICE_MPICommunication=ON \
          -DPRECICE_PETScMapping=ON \
          -DPRECICE_PythonActions=ON \
          -Wno-dev
    make
}

check() {
    cd "${pkgname}-${pkgver}"
    make test
}

package() {
    cd "${pkgname}-${pkgver}"
    make DESTDIR="${pkgdir}/" install
}
